
//
// Trust Design LLC : SECS/HSMS Communication library
//
// (c) Copyright Trust Design LLC.  2010-2019.  All rights reserved.
//


// =============================================================================
//
// BasicIo : Test and sample program
//
//  Construct a message in AP and simply send and receive SECS messages.
// 
//
// Starting method
//
//   BasicIo {h|e}
//   ~~~~~~~~~~~~~
//   h    : Refer to [HOST]  section of Sample.ini to determine operation
//   e    : Refer to [EQUIP] section of Sample.ini to determine operation
//
//
//   Normally, "BasicIo h" and "BasicIo e" both operate on same machine or
//   different machines to communicate with each other.
//
//   After startup, it refers to the menu display, inputs request codes (0,1,2),
//   etc., and executes functions such as receiving a message from the other
//   side and sending a message to the other side.
//
//   Execute functions such as receiving a message or sending a message to the
//   other side. Host side and equipment side do not use Callback function but
//   perform Receive processing according to request code.
//   When using a message definition file, message is sent out by defining it in
//   message definition file and specifying an arbitrary message name.
// 
//   When host starts up, it waits for a connection from equipment.
//   When equipment side is started, connection request and Select request are
//   automatically issued to host side. On host side, repeat "1:Recv" processing,
//   and confirm that display is "STATUS = 951: No data".  After that, exchange
//   any message. On receiving side, do not forget to reap received data until
//   "STATUS = 951".
//
//   The transaction ID used when sending secondary message uses that of primary
//   message received immediately before.
//
//   This sample omits some of abnormal processing.
//
//   The following "SECS_MODE" is defined to use _TDSCommXxxx() as processing
//   function and to judge whether or not connection processing to Passive side
//   in case of Active connection is performed.
//   In this sample, operation on eqipment side is assumed to be Active
//   operation.
//
//   The following "FUNC_TYPE" is defined to select type of processing function
//   to be used.
//   When using _TDSUDrvXxxx(), there is no need to perform connection
//   processing for HSMS-SS Active connection, so there is no need to set
//   "SECS_MODE" in principle.
//   TDS switches SECS-1 connection or HSMS connection in setting file (.ini).
//   When _TDSUDrvXxxx() is used, user AP is not necessary to know connection
//   method (SECS-1 or HSMS and  Passive or Active).
//   However, when using _TDSUDrvXxxx(), Callback processing needs to be
//   performed by itself.
//
//   By changing values of "MSSG_USE_FILE" and "MSSG_DISP_TYPE" defined below,
//   you can change output format of SECS message displayed by this AP.
//   By changing value of "MSSG_USE_NEXTL", it is possible to change whether to
//   acquire field values as data or display list format when analyzing message
//   contents.
//
//
// =============================================================================
//
// BasicIo : テスト 及び サンプル・プログラム
//
//  ＡＰ内でメッセージを構築し、単純に SECS メッセージの送受信を行う。
// 
//
// 起動方法
//
//   BasicIo {h|e}
//   ~~~~~~~~~~~~~
//   h    : Sample.ini の [HOST]  セクションを参照し動作を決定する
//   e    : Sample.ini の [EQUIP]      :              :
//
//
//   通常、BasicIo h 及び BasicIo e の両方を、同一マシン、もしくは異なる
//   マシン上で動作させて、相互通信を行う。
//
//   起動後、メニュ表示を参照し、要求コード (0,1,2) 等を入力し、相手側からの
//   メッセージを受信したり、相手側へメッセージを送出する等の機能を実行する。
//   ホスト側、装置側共に Callback 関数を使用せず、Receive 処理を要求コード
//   に応じて行う。
//   メッセージ定義ファイルを使用する場合は、メッセージ定義ファイルに定義した
//   任意のメッセージ名称を指定することにより、そのメッセージをを送出する。
// 
//   ホスト側は起動すると、装置側からの接続を待つ。装置側を起動すると、自動的
//   にホスト側に接続要求、Select 要求を発行する。ホスト側では、1:Recv 処理を
//   繰り返し行い、表示が「STATUS=951 : No data」となるのを確認する。その後、
//   任意のメッセージのやりとりを行う。受信側では、受信データの刈り取りを「
//   STATUS=951」になるまで行うことを忘れぬこと。
//
//   ２次メッセージを送信する際のトランザクションＩＤは、直前に受信した１次
//   メッセージのものを使用する。
//
//   本サンプルは、異常時処理を一部省略している。
//
//   以下で定義する "SECS_MODE" は、処理関数として _TDSCommXxxx() を使用する
//   場合で Active 接続の場合の Passive 側への接続処理の実行の有無を判断する
//   ために定義する。
//   なお、本サンプルは、装置側での動作を Active 動作と仮定している。
//
//   "FUNC_TYPE" は、使用する処理関数の種別を選択するために定義する。
//   _TDSUDrvXxxx() を使用する場合は、HSMS-SS Active 接続の場合の接続処理を行
//   う必要がないので、本来であれば "SECS_MODE" の設定も必要がない。
//   TDS は、SECS-1 接続 or HSMS-SS 接続の切替は、設定ファイル (.ini) にて行う
//   ため、処理関数として _TDSUDrvXxxx() を使用する限りは、ユーザＡＰでは、
//   接続方式（SECS-1/HSMSS そして HSMS-SS時の Passive/Active）を知る必要は
//   ない。ただし _TDSUDrvXxxx() を使用する場合は、Callback 処理は自力で行う
//   必要がある。
//
//   以下で定義する "MSSG_USE_FILE"、"MSSG_DISP_TYPE" の値を変更すると、本ＡＰ
//   にて表示する SECS メッセージの出力形式を変更できる。
//   "MSSG_USE_NEXTL" の値を変更すると、メッセージ内容を解析する際に、項目値を
//   データとして取得するか、表示リスト形式で取得するかを変更できる。
//
// =============================================================================

#include	"TDS.h"


#define		PO		fprintf(stdout
#define		PE		fprintf(stderr

#define		SECS_MODE	1		// SECS/HSMS mode
						// 0    : SECS-1
						// 1    : HSMS
#define		FUNC_TYPE	0		// Type of function used 
						// 通信に使用する関数の種別
						// 0    : _TDSCommXxxxx()
						// 1    : _TDSUDrvXxxxx()
#define		UDRV_MASK  	0x8383ffff	// Mask value for UDrvOpen()
						// 0          : Set =0x49
						// 0x8383ffff : All event

#define		MSSG_USE_FILE	0x80		// Message definition file
						// 0x00 : Not use
						// 0x80 : Use to display item
						//	  names
						//	  使用して項目名表示する
#define		MSSG_DISP_TYPE	0x20		// SECS Message display format
						// 0x00 : TDS Format
						// 0x20 : SML Format
#define		MSSG_USE_NEXTL	1		// Use MssgNextL() or not
						// 0    : Not use
						// 1    : Use


#define		PARAMFILE	"Sample.ini"


static void	Host();
static void	Equip();



// =============================================================================
// Common functions ============================================================

#include	"SubFunctions.h"



// =============================================================================
// Main process ----------------------------------------------------------------

int
main(
int			argc,
char			*argv[])
{
  if(argc<2 || (argv[1][0]!='h' && argv[1][0]!='e')){
    PE,"Usage: %s {host|equip}\n"	,argv[0]);		exit(1);
  }
//InitializeCriticalSection(&Cs0);
  InitializeCriticalSection(&Cs1);

  if(argv[1][0]=='h')	Host ();
  else			Equip();

//DeleteCriticalSection(&Cs0);
  DeleteCriticalSection(&Cs1);
  exit(0);
}



// =============================================================================
// Host side process -----------------------------------------------------------

static void
Host()
{
  TDSECSHead		hd;
  char			msg[1024],mname[64];
  unsigned int		xid,xids=0;
  int			did,dids=0;
  int			req,rtn,msz,mno;

  msz=sizeof(msg);
  if(FUNC_TYPE==0)	Fd=_TDSCommOpen(0x02,PARAMFILE,"HOST",0,0,0,0,0,0);
  else			Fd=_TDSUDrvOpen(0x02,PARAMFILE,"HOST",UDRV_MASK);
  if(Fd								< 0) goto Exit;
  PO,"(H) Opened (%d)\n",Fd);
  if((MSSG_USE_FILE&0x80)!=0) Md=_TDSMDMssgInitialize(0x4000,Fd,0);

  for(;;){
    PE,"Req (0:Exit 1:Recv 2:Send) : ");	scanf("%d",&req);
    if      (req==0){						break;

    }else if(req==1){
      if(FUNC_TYPE==0)	rtn=_TDSCommRecv(Fd,0,&did,0,&xid,msg,msz,&hd);
      else		rtn=_TDSUDrvRecv(Fd,0,&did,0,&xid,msg,msz,&hd);
      if(rtn	>=0){	dids=did;	xids=xid;}
      DispData(1,&hd,msg,rtn,rtn);

    }else if(req==2){
      PE,"Message(1:S1F1 2:S2F49   6:S1F2 7:S6F12   9:Any) : ");
      scanf("%d",&mno);
      switch(mno){
	case 1: rtn=SendS1F1 ();			break;
	case 2: rtn=SendS2F49();			break;
	case 6: rtn=SendS1F2H(dids,xids);		break;
	case 7: rtn=SendS6F12(dids,xids);		break;
	case 9: if((MSSG_USE_FILE&0x80)!=0){
		  PE,"Message Name : ");	scanf("%s",mname);
		  rtn=SendNamedMssg(dids,xids,mname);
		}					break;
    } }
    if(rtn<(-999) || ((-900)<rtn && rtn<0)){
      PE,"(H) I/O Error (%d)\n",	rtn);
  } }

Exit:
  if(Md>0)		_TDSMDMssgTerminate(Md,0);
  if(Fd>0){
    if(FUNC_TYPE==0)	_TDSCommClose(Fd,0);
    else		_TDSUDrvClose(Fd,0);
  } else		PE,"(H) Error (%d)\n",Fd);
}



// =============================================================================
// Equipment side process ------------------------------------------------------

static void
Equip()
{
  TDSECSHead		hd;
  char			msg[1024],mname[64];
  unsigned int		xid,xids=0;
  int			did,dids=0;
  int			req,rtn,msz,mno;

  msz=sizeof(msg);
  if(FUNC_TYPE==0)	Fd=_TDSCommOpen(0x02,PARAMFILE,"EQUIP",0,0,0,0,0,0);
  else			Fd=_TDSUDrvOpen(0x02,PARAMFILE,"EQUIP",UDRV_MASK);
  if(Fd								< 0) goto Exit;
  PO,"(E) Opened (%d)\n",Fd);
  if((MSSG_USE_FILE&0x80)!=0) Md=_TDSMDMssgInitialize(0x4000,Fd,0);
  if(SECS_MODE!=0 && FUNC_TYPE==0){	// In case of HSMS and use TDSCommXxxxx()
					// HSMS で TDSComm 使用の場合
    if(_TDSCommSend(Fd,0x0100,0,0,0,0,0,0)			< 0) goto Exit;
    PO,"(E) Connected\n");
    if(_TDSCommSend(Fd,0x0200,0,0,0,0,0,0)			< 0) goto Exit;
    PO,"(E) Selected\n");
  }

  for(;;){		rtn=0;
    PE,"Req (0:Exit 1:Recv 2:Send) : ");	scanf("%d",&req);
    if      (req==0){						 break;

    }else if(req==1){
      if(FUNC_TYPE==0)	rtn=_TDSCommRecv(Fd,0,&did,0,&xid,msg,msz,&hd);
      else		rtn=_TDSUDrvRecv(Fd,0,&did,0,&xid,msg,msz,&hd);
      if(rtn	>=0){	dids=did; xids=xid;}
      DispData(1,&hd,msg,rtn,rtn);

    }else if(req==2){
      PE,"Message(1:S1F1 2:S6F11   6:S1F2 7:S2F50   9:Any) : ");
      scanf("%d",&mno);
      switch(mno){
	case 1: rtn=SendS1F1 ();			break;
	case 2: rtn=SendS6F11();			break;
	case 6: rtn=SendS1F2E(dids,xids);		break;
	case 7: rtn=SendS2F50(dids,xids);		break;
	case 9: if((MSSG_USE_FILE&0x80)!=0){
		  PE,"Message Name : ");	scanf("%s",mname);
		  rtn=SendNamedMssg(dids,xids,mname);
		}					break;
    } }
    if(rtn<(-999) || ((-900)<rtn && rtn<0)){
      PE,"(E) I/O Error (%d)\n",	rtn);
  } }

  if(SECS_MODE!=0){			// In case of HSMS, Shutdown process
					// HSMS の場合、切断処理
  // Deselect request is not performed. (Of course you may go. However SEMI
  // claims that HSMS-SS does not perform Deselect request.)
  // Deselect request は行わない。 (もちろん行ってもよい。SEMI では HSMS-SS に
  // おいて、Deselect request は行なわない、としている。)
  //if(FUNC_TYPE==0)	rtn=_TDSCommSend(Fd,0x0800,0,0,0,0,0,0);
  //else		rtn=_TDSUDrvSend(Fd,0x0800,0,0,0,0,0,0);
  //if(rtn							< 0) goto Exit;
  //PO,"(E) Deselected\n");
    if(FUNC_TYPE==0)	rtn=_TDSCommSend(Fd,0x0900,0,0,0,0,0,0);
    else		rtn=_TDSUDrvSend(Fd,0x0900,0,0,0,0,0,0);
    if(rtn							< 0) goto Exit;
    PO,"(E) Separate\n");
  }

Exit:
  if(Md>0)		_TDSMDMssgTerminate(Md,0);
  if(Fd>0){
    if(FUNC_TYPE==0)	_TDSCommClose(Fd,0);
    else		_TDSUDrvClose(Fd,0);
  } else		PE,"(E) Error (%d)\n",Fd);
}
